// -------------------------------------------------------------
// 3d code by Georgy Moshkin (Delphi)
//
// BLENDER NFT LOADER v2008.1.6 (Delphi/OpenGL)
//
// horse model by Damien McGinnes
// horse texture by Andor Holtzmark
// exgine.dll by XProger
//
// note:
// glTexCoord2f(u,v); 
// glTexCoord2f(u,1-v);
// -------------------------------------------------------------

program example;

uses
  OpenGL,eXgine,skeleton,mesh,texture,nftloader,render,sysutils;


var mdl:TMeshes;
    skanim:TSkeletonAnimation;
    xstate:TSkeletonState;
    myts:TTextures;


// -=(    )=-
procedure Update;
begin
//    Escape (  27)
  if inp.Down(27) then eX.Quit;

end;


var k:integer;
    oldTime:Integer;
// -=(    )=-
procedure Render;
var i:integer;
begin
  glClearColor(0.3,0.3,0.3,1);
  ogl.Clear(true, true); //  
  ogl.Set3D(45, 0.1, 512); //    

  glTranslatef(0,-2,-7);
  glRotatef(-90,1,0,0);
  glRotatef(-90,0,0,1);
//  glRotatef(ex.GetTime/50,0,0,1);


  glEnable(GL_DEPTH_TEST);


for i:=0 to length(mdl)-1 do
      DrawPolys(mdl[i]);

  tex.Disable();

  (*
  glColor3f(1,0,0);
for i:=0 to length(mdl)-1 do
      DrawPolysWire(mdl[i]);

for i:=0 to length(mdl)-1 do
      DrawNormals(mdl[i]);
    *)

if xstate.nextFrame>=length(skanim.actions[k].animFrames)-1 then
 k:=k+1;

if k>length(skanim.actions)-1 then k:=0;




  glDisable(GL_DEPTH_TEST);
 glColor3f(1,1,1);


   glPointSize(3.0);
   DrawNodes( xstate.currentPose);


    glColor3f(0,0,1);
   DrawBones( xstate.currentPose,skanim.skeleton);


Anim(skanim.actions,
     xstate,
     k,
     ex.GetTime-oldTime{ex.GetTime+10});
oldTime:=ex.GetTime;

  BuildFrame(xState.currentPose{skanim.actions[k].animFrames[j]},skanim.skeleton);

for i:=0 to length(mdl)-1 do

   Transform(mdl[i].verts,
             mdl[i].restverts,
             mdl[i].vertsParents,
             xState.currentPose{skanim.actions[k].animFrames[j]}
             ,
             skanim.reference,
             skanim.skeleton);



  ogl.Set2D(0, 0, wnd.Width, wnd.Height);
  tex.Disable();
  glColor3f(1, 1, 1);


  ogl.TextOut(0, 8, 16, 'BLENDER NFT LOADER v2008.1.6 (Delphi/OpenGL)');
  ogl.TextOut(0, 8, 32, 'Source code for Delphi by Georgy Moshkin');

  ogl.TextOut(0, 8, 64, 'Buggy angles linear interpolation without quaternions');

  ogl.TextOut(0, 8, 64+16*2, PChar( 'Action['+intToStr(xstate.prevAction)+']='+ skanim.actions[xstate.prevAction].name ));
  ogl.TextOut(0, 8, 64+16*3, PChar('Frame='+intToStr(xstate.prevFrame)));
  ogl.TextOut(0, 8, 64+16*4, PChar('DTime='+floatToStrF(xstate.skelTime,ffFixed,3,3)));




end;


// -=(   )=-
var i:integer;
begin

  //    
  wnd.Create('BLENDER NFT LOADER v2008.1.6 (Delphi/OpenGL)');

  //    ,     
  eX.SetProc(PROC_UPDATE, @Update);
  eX.SetProc(PROC_RENDER, @Render);

  //   log-
  log.Print('Hello World!');



   inp.MCapture(true); //  "" 

  //    
  wnd.Mode(False, 640, 480, 32, 75);

//loadnft('hl2export.nft',mdl,skanim,myts);

loadnft('horce.nft',mdl,skanim,myts);


for i:=0 to length(mdl)-1 do
BuildSkeleton(mdl[i].verts,
         mdl[i].restverts,
         mdl[i].vertsParents,
         skanim.reference,
         skanim.skeleton);

  //    
  eX.MainLoop(50);
end.

