// -------------------------------------------------------------
// 3d code by Georgy Moshkin (Delphi)
// -------------------------------------------------------------
unit texture;

interface

uses OpenGL, exgine;

type TMyTexture = record
                   exID  : TTexture;
                   fname : string;
                  end;

type TTextures = array of TMyTexture;

function LoadMyTexture(var textures:TTextures;fname:string):longword;

implementation

function LoadMyTexture(var textures:TTextures;fname:string):longword;
var i:integer;
    loaded:boolean;
begin
 loaded:=false;
 for i:=0 to length(textures)-1 do
  if textures[i].fname=fname then
   begin
    loaded:=true;
    result:=textures[i].exID;
   end;

  if not loaded then
   begin
    i:=length(textures);
    setlength(textures,i+1);
    textures[i].fname:=fname;
    textures[i].exID:=tex.Load(PChar(fname));
    result:=textures[i].exID;    
   end;


end;

end.
